Index: channels/chan_modem.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_modem.c,v
retrieving revision 1.29
diff -u -r1.29 chan_modem.c
--- channels/chan_modem.c	3 Oct 2004 04:19:58 -0000	1.29
+++ channels/chan_modem.c	23 Oct 2004 09:32:48 -0000
@@ -510,7 +510,19 @@
 	return res;
 }
 
+static int modem_fixup(struct ast_channel *oldchan, struct ast_channel *newchan)
+{
+        struct ast_modem_pvt *p = newchan->pvt->pvt;
+ast_log(LOG_WARNING, "fixup called\n");
+	if (p->owner!=oldchan) {
+	    ast_log(LOG_WARNING, "old channel wasn't %p but was %p\n",oldchan,p->owner);
+	    return -1;
+	}
+	p->owner = newchan;
+        return 0; 
+}
+
 struct ast_channel *ast_modem_new(struct ast_modem_pvt *i, int state)
 {
 	struct ast_channel *tmp;
 	tmp = ast_channel_alloc(1);
@@ -529,6 +543,7 @@
 		tmp->pvt->answer = modem_answer;
 		tmp->pvt->read = modem_read;
 		tmp->pvt->write = modem_write;
+		tmp->pvt->fixup = modem_fixup;
 		strncpy(tmp->context, i->context, sizeof(tmp->context)-1);
 
 		if (!ast_strlen_zero(i->cid_num))
